#include <iostream>
#include <fstream>
#include "StructKaoSwap.h"

using namespace std;


char szKaoswapFileName[]		= "KAOSWAP.N6P";
char szKaoswapExFileName[]		= "KAOSWAPEX.N6P";
char szKaoswapExSilhouette[]	= "KaoswapEXMaker.dat2";

KAOSWAP_TENSHOUKI<1332>	srcKaoSwap;		// KAOSWAP  \z邽߂̃oCi
KAOSWAP_TENSHOUKI<1932>	dstKaoSwapEX;	// KAOSWAPEX\z邽߂̃oCi

// KaoSwapExp̃VGbg
struct KAOSWAP_TENSHOUKI_SILHOUETTE
{
	KAOSWAP_TENSHOUKI_FACE_64x80 face[600];
} srcKaoSwapSilhouette;

enum ErrorType { NoErr=0,  ErrNoTargetFile=-1,ErrNoKaoSwap=-6, ErrDefaultKaoswap=-8, ErrBrokenKaoswap=-9 };

/*
 * Xbvt@CǂsrcKaoSwapɊi[B
 */
ErrorType ReadKaoSwap() {
	fstream inKaoSwap;

	// ꂪƁAȂt@CFȂƂc
	DWORD dwAttr = ::GetFileAttributes(szKaoswapFileName);

	if(dwAttr == 0xffffffff) {
		cout << endl << "NoExist:" << szKaoswapFileName << endl;
	}

	if (!inKaoSwap) { return ErrNoKaoSwap; }


	inKaoSwap.open(szKaoswapFileName, ios::in|ios::binary);

	// Xbv\̂ւƃRs[
	inKaoSwap.read( (char *)(&srcKaoSwap), sizeof(srcKaoSwap) );

	// t@CTCY𒲂ׂ
	size_t fileSize = (size_t)inKaoSwap.seekg(0, ios::end).tellg();

	cout << (int)fileSize << endl;

	// CDftHB
	if ( fileSize == 339854 ) {
		return ErrDefaultKaoswap;
	}

	// Xg[̃|C^ԑO sv܂ÂŁc
	inKaoSwap.seekg(0, ios::beg);

	return NoErr;
}

/*
 * XbvpVGbgt@CǂsrcKaoSwapSilhouetteɊi[B
 */
ErrorType ReadKaoSwapSilhouette() {
	fstream inKaoSwap;

	// ꂪƁAȂt@CFȂƂc
	DWORD dwAttr = ::GetFileAttributes(szKaoswapExSilhouette);
	if(dwAttr == 0xffffffff) {
		cout << endl << "NoExist:" << szKaoswapExSilhouette << endl;
	}

	inKaoSwap.open(szKaoswapExSilhouette, ios::in|ios::binary);

	if (!inKaoSwap) { return ErrNoTargetFile; }

	// Xbv\̂ւƃRs[
	inKaoSwap.read( (char *)(&srcKaoSwapSilhouette), sizeof(srcKaoSwapSilhouette) );
	return NoErr;

}

/*
 * fop\̂łdstKaoSwapEX
 */
void InitKaoswapEx() {
	// EX̃tO͑SĂPɎdĂȂ
	memset( dstKaoSwapEX.flag, 0x01, sizeof(dstKaoSwapEX.flag) );

	// EX̊e͑S0xFFԂɂBSĂ̊͐^
	memset( dstKaoSwapEX.face, 0xFF, sizeof(dstKaoSwapEX.face) );
}

/*
 * srcKaoWwap\́dstKaoSwapEXւƃRs[BtOAƂ擪̐lRs[
 */
void CopyKaoswapToKaoswapEx() {
	memcpy((char *)(&dstKaoSwapEX.flag), (char *)(&srcKaoSwap.flag), sizeof(srcKaoSwap.flag) );
	memcpy((char *)(&dstKaoSwapEX.face), (char *)(&srcKaoSwap.face), sizeof(srcKaoSwap.face) );
}

/*
 * dstKaoSwapEX̎c̕srcKaoSwapSilhouetteRs[
 */
void CopyKaoswapSilhouetteToKaoswapEx() {
	// 0IWŁA1332Ԉȍ~
	memcpy((char *)(&dstKaoSwapEX.face[1332]), (char *)(&srcKaoSwapSilhouette.face), sizeof(srcKaoSwapSilhouette.face) );
}

/*
 * XbvpKaoswapEX.n6pt@CdstKaoSwapEX\̂珑o
 */
ErrorType WriteKaoSwap() {
	fstream outKaoSwap;

	outKaoSwap.open(szKaoswapExFileName, ios::out|ios::binary);

	if (!outKaoSwap) { return ErrNoKaoSwap; }

	// XbvւƏ
	outKaoSwap.write( (char *)(&dstKaoSwapEX), sizeof(dstKaoSwapEX) );
	return NoErr;

}

void main(void) {

	ErrorType iErr = ReadKaoSwap();
	if ( iErr == ErrDefaultKaoswap ) {
		cout <<  "̃t@CCDYt̂̂ƓłB1332lpƂĂ1932lpƂĂp\łB̕Kv͂܂B" << endl;
		cout << "\nĂc\n";
		getchar();
		exit(-1);
	}
	if ( iErr == ErrBrokenKaoswap ) {
		cout << "KAOSWAP.N6P͂łɃc[ŔFs\ȏԂƂȂĂ܂Ă܂Bo܂B" << endl;
		cout << "\nĂc\n";
		getchar();
		exit(-1);
	}

	cout <<  "KAOSWAP.N6P̊̉摜𓊉eāAKAOSWAPEX.N6P쐬܂B\n";
	cout <<  "KAOSWAPEX.N6P ݂ƂĂAe͂Ȃ㏑܂!!BobNAbvƂƂȂ獡!!\n";
	cout <<  "蔲c[ł߂˥orz\n";
	cout <<  "\nĂc\n";
	getchar();

	// -------------ʏ폈X^[g---------------
	ReadKaoSwapSilhouette();

	InitKaoswapEx();

	CopyKaoswapToKaoswapEx();
	CopyKaoswapSilhouetteToKaoswapEx();

	WriteKaoSwap();
}

